import jm.music.data.*;
import jm.JMC;
import jm.util.*;
import jm.music.tools.*;
 
public class SongPart {
  
  /*
   * SongPart has a Part
   */
  public Part myPart;
  /*
   * SongPart has a SongNode that is the beginng of its
   */
  public SongNode myList;
  
  /**
   * Construct a SongPart
   * @param instrument MIDI instrument (program)
   * @param startNode where the song list starts from
   */
  public SongPart(int instrument, SongNode startNode)
  {
    myPart = new Part(instrument);
    myList = startNode;
  }
  
  /**
   * Collect parts of this SongPart
   */
  public Phrase collect(){
    return this.myList.collect();  // delegate to SongNode's collect
  }
  
   /**
   * Collect all notes in this SongPart and open it up for viewing.
   */
  public void show(){
    // Make the Score that we'll assemble the part into
    // We'll set it up with a default time signature and tempo we like
    // (Should probably make it possible to change these -- maybe with inputs?)
     Score myScore = new Score("My Song");
     myScore.setTimeSignature(3,4);
     myScore.setTempo(120.0);
               
     // Now, construct the part and the score.
     this.myPart.addPhrase(this.collect());
     myScore.addPart(this.myPart);
     
     // At the end, let's see it!
     View.notate(myScore);

  }

}
